<!DOCTYPE html>
<html>
    
<head>
<title>Submit Workflow</title>


<meta http-equiv="Content-Security-Policy" content="upgrade-insecure-requests">

<script src="https://cdnjs.cloudflare.com/ajax/libs/jquery.form/4.3.0/jquery.form.min.js" integrity="sha384-qlmct0AOBiA2VPZkMY3+2WqkHtIQ9lSdAsAn5RUJD/3vA5MKDgSGcdmIv4ycVxyn" crossorigin="anonymous"></script>
<link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@5.1.1/dist/css/bootstrap.min.css" crossorigin="anonymous">

<link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap-icons@1.5.0/font/bootstrap-icons.min.css" crossorigin="anonymous">    
<link href="https://cdn.jsdelivr.net/gh/kartik-v/bootstrap-fileinput@5.2.5/css/fileinput.min.css" media="all" rel="stylesheet" type="text/css" />    
<script src="https://code.jquery.com/jquery-3.6.0.min.js" crossorigin="anonymous"></script>
<script src="https://cdn.jsdelivr.net/gh/kartik-v/bootstrap-fileinput@5.2.5/js/plugins/piexif.min.js" type="text/javascript"></script>
<script src="https://cdn.jsdelivr.net/gh/kartik-v/bootstrap-fileinput@5.2.5/js/plugins/sortable.min.js" type="text/javascript"></script>    
<script src="https://cdn.jsdelivr.net/npm/bootstrap@5.1.1/dist/js/bootstrap.bundle.min.js" crossorigin="anonymous"></script>
<script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.14.7/umd/popper.min.js"></script>
<script src="https://stackpath.bootstrapcdn.com/bootstrap/4.3.1/js/bootstrap.min.js"></script>
<script src="https://code.jquery.com/jquery-3.6.0.js"></script>
<script src="https://code.jquery.com/ui/1.13.2/jquery-ui.js"></script>
<link rel="stylesheet" href="//code.jquery.com/ui/1.13.2/themes/base/jquery-ui.css">
<link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.2.1/css/bootstrap.min.css" integrity="sha384-GJzZqFGwb1QTTN6wy59ffF1BuGJpLSa9DkKMp0DgiMDm4iYMj70gZWKYbI706tWS" crossorigin="anonymous">
<link href="//maxcdn.bootstrapcdn.com/bootstrap/4.0.0/css/bootstrap.min.css" rel="stylesheet" id="bootstrap-css">
<script src="//maxcdn.bootstrapcdn.com/bootstrap/4.0.0/js/bootstrap.min.js"></script>
</html>



</head>
<body>
    <nav class="navbar navbar-expand-md navbar-light bg-light">
        
        <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarSupportedContent" aria-controls="navbarSupportedContent" aria-expanded="false" aria-label="Toggle navigation">
            <span class="navbar-toggler-icon"></span>
        </button>

        <div class="collapse navbar-collapse" id="navbarSupportedContent">
            <ul class="navbar-nav mx-auto">
                <li class="nav-item active">
                    <a class="nav-link" href="/">Home</a>
                </li>
                <li class="nav-item">
                    <a class="nav-link" href="{{ url_for('submit_workflow')}}">Submit Workflow</a>
                </li>
                <li class="nav-item">
                    <a class="nav-link" href="{{ url_for('workflow_metadata')}}">Workflow Metadata</a>
                </li>
                <li class="nav-item">
                    <a class="nav-link" href="{{ url_for('group_workflow_metadata')}}">Group Workflow Metadata</a>
                </li>
                <li class="nav-item">
                    <a class="nav-link" href="{{url_for('inputs')}}">Input Files</a>
                </li>
                <li class="nav-item">
                    <a class="nav-link" href="{{ url_for('outputs')}}">Output Files</a>
                </li>
               <li class="nav-item">
                    <a class="nav-link" href="{{ url_for('logout')}}"><b>Logout</b></a>
                </li>

            </ul>
        </div>
    </nav>
    <br>
    <br>
    <div class="text-center">
        <h6> <b>Submit your workflow</b></h6>
    </div>
   
    
    <div class="container">
        <div class="row">
          <div class="col">
    
            <div class="mb-3 mt-3">
    
              <div class="form-group mb-3">

                <label for="workflow_type" class="form-label"><b> Workflow Type </b></label>
                <div class="form-check">
                    <ul>
                        {% for workflow_type in data %}
                            {% if (workflow_type != "access_token") %}
                                <li> <input type="radio"  class="form-check-input" id="{{workflow_type}}" name="workflow_type" value='{{workflow_type}}' > {{workflow_type}} </li>
                            {%endif%}
                        {%endfor%}
                    </ul>
                </div>
                <div>
                    {% for workflow_type in data %}
                        {% if (workflow_type != "access_token") %}
                            <div name="rest-form" id="rest-form-{{workflow_type}}" style="display:none">
                                <div class="mb-2">
                                    <label for="ref_number" class="form-label"><b>  </b></label>
                                    <input type="text" name="ref_number" class="form-control" id="ref_number_{{workflow_type}}" aria-describedby="ref_number" placeholder="Referral Number" required>
                                </div>
                                <label for="input_type" class="form-label"><b> Input Options </b></label>
                                <div class="form-check" id="input_type_{{workflow_type}}">
                                    <ul>   
                                        <li> <input type="radio"  class="form-check-input" id="{{workflow_type}}-sample-id" name="input_type" value='sample-id' > Find Samples </li>
                                        <li> <input type="radio"  class="form-check-input" id="{{workflow_type}}-attach" name="input_type" value='attach' > Attach Input Files </li>
                                    </ul>
                                </div>
                                         
                                <div name="files-form" id="input-form-{{workflow_type}}-attach" style="display:none">
                                    {% for i in range (0,data[workflow_type]["required"] | length) %}
                                        <div class="custom-file form-control-sm mb-4">
                                            <label for="input_file_{{workflow_type}}_{{i}}" name="input_file_label" id="input_file_label_{{workflow_type}}_{{i}}" class="custom-file-label"> {{data[workflow_type]['required'][i]}}</label>
                                            <input type="file" name="input_file" id="input_file_{{workflow_type}}_{{i}}" oninput="input_filename('input_file_label_{{workflow_type}}_{{i}}','input_file_{{workflow_type}}_{{i}}');" required>
                                        </div>               
                                    {%endfor%}
                                    {% set number_of_files = data[workflow_type]["required"] | length %}
                                    {% set access_token = data["access_token"] %}
                                    <br>
                                    <div class="form-center">
                                        <button onclick="upload('{{ request.url }}', '{{workflow_type}}','{{number_of_files}}', '{{access_token}}');" id="upload_btn_attach" class="btn btn-primary" style="width: 25%">Submit</button>
                                    </div>
                                </div>
                                <div name="files-form" id="input-form-{{workflow_type}}-sample-id" style="display:none">
                                    <div class="mb-0">
                                        <label for="input_collection_date_{{workflow_type}}" class="form-label"><b>  </b></label>
                                        <input type="text" name="input_collection_date" class="form-control" id="input_collection_date_{{workflow_type}}" value="" placeholder="Collection Date" required>
                                    </div>
                                    <br>
                                    <div class="mb-0">
                                        <select class="form-select"  name="input_center_name"  id="input_center_name_{{workflow_type}}" placeholder="Center Name">
                                            <option selected disabled value="">Center Name</option>
                                            <option value="Centre for research and Technology Hellas - Institute of Applied Biosciences">Centre for research and Technology Hellas - Institute of Applied Biosciences</option>
                                            <option value="INSTITUTE OF APPLIED BIOSCIENCES - CERTH">INSTITUTE OF APPLIED BIOSCIENCES - CERTH </option>
                                            <option value="Greek Genome Center, Biomedical Research Foundation Academy of Athens">Greek Genome Center, Biomedical Research Foundation Academy of Athens</option>
                                        </select>
                                    </div> 
                                    <br>
                                    <div class="mb-0">
                                        <select class="form-select"  name="input_host_sex"  id="input_host_sex_{{workflow_type}}" placeholder="Center Name">
                                            <option selected value="">Any Host Sex</option>
                                            <option value="Male">Male</option>
                                            <option value="Female">Female </option>
                                        </select>
                                    </div>                                            
                                    {% set number_of_files = data[workflow_type]["required"] | length %}
                                    {% set access_token = data["access_token"] %}
                                    <br>
                                    <div class="form-center">
                                        <button onclick="find_samples('{{ request.url }}', '{{workflow_type}}', '{{access_token}}');" id="find_samples_btn" class="btn btn-primary" style="width: 25%">Find</button>
                                    </div>
                                </div>
                                <div id="search_results_{{workflow_type}}"></div>

                            </div>
                        {%endif%}
                    {%endfor%}
                </div>

              </div>
            </div>
    
            <div id="progress_wrapper" class="d-none">
              <label id="progress_status"></label>
              <div class="progress mb-3">
                <div id="progress" class="progress-bar" role="progressbar" aria-valuenow="25" aria-valuemin="0" aria-valuemax="100"></div>
              </div>
            </div>

                <button class="btn btn-primary d-none" id="loading_btn" type="button" disabled>
                <span class="spinner-border spinner-border-sm" role="status" aria-hidden="true"></span>
                Submitting...
                </button>

            <div id="alert_wrapper"></div>
    
          </div>
        </div>
      </div>

   
    
   
    <script>
     // Get a reference to the progress bar, wrapper & status label

        var progress = document.getElementById("progress");
        var progress_wrapper = document.getElementById("progress_wrapper");
        var progress_status = document.getElementById("progress_status");

        // Get a reference to the 3 buttons
        var upload_btn_attach = document.getElementById("upload_btn_attach");
        var loading_btn = document.getElementById("loading_btn");

        // Get a reference to the alert wrapper
        var alert_wrapper = document.getElementById("alert_wrapper");
        $( function() {
            $('[id^=input_collection_date]').datepicker({
                dateFormat: 'yy-mm-dd'
            }

            );
         } );

        // Function to show alerts
        function show_alert(message, alert) {

            alert_wrapper.innerHTML = `
                <div id="alert" class="alert alert-${alert} alert-dismissible fade show" role="alert">
                <span>${message}</span>
                <button type="button" class="close" data-dismiss="alert" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                </button>
                </div>
            `
        }

        function find_samples(url,workflow_type,access_token) {
            var collection_date_element = document.getElementById("input_collection_date_" + workflow_type);
            var center_name_element = document.getElementById("input_center_name_" + workflow_type);
            var host_sex_element = document.getElementById("input_host_sex_" + workflow_type);
            var search_form = document.getElementById("input-form-" + workflow_type + "-sample-id");

            collection_date = collection_date_element.value;
            center_name = center_name_element.value;
            host_sex = host_sex_element.value;



            var request = new XMLHttpRequest();
            var data = "result=sample&format=tsv";

            var query_uri = "";
            if(collection_date != "") query_uri += ( "collection_date=" + collection_date ) ;
            if(center_name != ""){
                if(query_uri != "") query_uri += " AND ";
                query_uri += ( "center_name=" + '"' + center_name + '"') ;
            }
            
            if(host_sex != ""){
                if(query_uri != "") query_uri += " AND ";
                query_uri += ( "host_sex=" + '"' + host_sex + '"') ;
            }

            if(query_uri != "") data += ("&query=" + query_uri);
        
        
            request.open("post", "https://www.ebi.ac.uk/ena/portal/api/search");
            request.setRequestHeader("Content-Type", 'application/x-www-form-urlencoded');
            request.send(data);

            var accessions = []
            request.addEventListener("load", function (e) {
                responseText =  request.responseText;
                lines = responseText.split("\n");
                for (let i = 1; i < lines.length; i++) {
                    var accession = lines[i].split('\t')[0];
                    if(accession != ""){
                        accessions.push(accession);
                    }   
                }
                // search_form.style.display = 'none';
                var search_modal = document.getElementById("search_results_"+ workflow_type);
                search_modal.innerHTML += `
                <div class="modal fade bd-example-modal-lg" id="results_modal_${workflow_type}" tabindex="-1" role="dialog" aria-labelledby="results_modal_label_${workflow_type}" aria-hidden="true">
                    <div class="modal-dialog" role="document">
                        <div class="modal-content">
                            <div class="modal-header">
                                <h5 class="modal-title" id="results_modal_label_${workflow_type}">Search Results</h5>
                            </div>
                            <div class="modal-body" id="results_modal_body_${workflow_type}" > </div>
                        </div>
                    </div>
                </div>
                `
                var modal_body = document.getElementById("results_modal_body_"+ workflow_type);
                modal_body.innerHTML += `
                <div>
                    <input id="selected_input_${workflow_type}" placeholder="Select Sample ID" autoComplete="on" list="results_${workflow_type}"/>                 
                    <datalist id="results_${workflow_type}"> </datalist>
                    <button type="button" onclick="test('${url}','${workflow_type}','${access_token}');" class="btn btn-primary" style="width: 15%">Submit </button>
                </div>
                `
               results = document.getElementById("results_" + workflow_type);
                for (var i = 0; i < accessions.length; i++) {
                    results.innerHTML += `
                            <option value="${accessions[i]}">
                     `
                }

                $('#results_modal_' + workflow_type ).modal('show');
                

            });
           
        }  
        function test(url,workflow_type,access_token){
            selected_value = document.getElementById("selected_input_" + workflow_type).value;
            var ref_number = document.getElementById("ref_number_" + workflow_type).value;
            var modal_body = document.getElementById("results_modal_body_"+ workflow_type);
            if(ref_number == ""){
                $('#results_modal_' + workflow_type ).modal('hide'); 
                show_alert("Referral number was not provided", "warning");
            }
            else{
                var new_data = new FormData();

                // Create a XMLHTTPRequest instance
                var request1 = new XMLHttpRequest();
                const last_index = url.lastIndexOf('/');
                const endpoint = url.slice(last_index+1);

                var new_endpoint= "can_be_submitted?ref_number=" + ref_number;
                let new_url = url.replace(endpoint,new_endpoint);
            
                request1.open("get", new_url);
                request1.setRequestHeader("Authorization", 'Bearer '+ access_token);
                
                new_data.append("ref_number",ref_number);
                request1.send(new_data);

                request1.addEventListener("load", function (e) {
                    if (request1.status != 200)
                    {
                        responseText =  request1.responseText;
                        var error_data = JSON.parse(JSON.stringify(responseText));
                        var obj = JSON.parse(error_data.replace(/'/g, '"'));
                        var data = eval(obj);

                        $('#results_modal_' + workflow_type ).modal('hide');
                        modal_body.innerHTML = "";
                        show_alert(`Error ${data["data"]["parsed_response"]["code"]} occured while submitting workflow: ${data["data"]["parsed_response"]["message"]} `, "danger");
                        return;
                    }
                    else
                    {
                        // Create a new FormData instance
                        var data = new FormData();
                        var request = new XMLHttpRequest();
                        request.responseType = "text";
                        alert_wrapper.innerHTML = "";

                        // Show the loading button
                        loading_btn.classList.remove("d-none");
                        data.append("ref_number",ref_number);
                        data.append("workflow_type",workflow_type);
                        data.append("sample_id",selected_value)

        
                        // request load handler (transfer complete)
                        request.addEventListener("load", function (e) {

                            if (request.status == 200) {
                                loading_btn.classList.add("d-none");
                                $('#results_modal_' + workflow_type ).modal('hide');
                                modal_body.innerHTML = "";
                                show_alert(`Workflow with referral number ${ref_number} was succesfully submitted` , "success");
                            }
                            else if (request.status == 401){
                                $('#results_modal_' + workflow_type ).modal('hide');
                                modal_body.innerHTML = "";
                                show_alert(`Your session has expired. Please login again` , "danger");
                            }
                            else {
                                responseText =  request.responseText;
                                console.log(responseText);
                                var error_data = JSON.parse(JSON.stringify(responseText))
                                var obj = JSON.parse(error_data.replace(/'/g, '"'));
                                var data = eval(obj);
                                
                                loading_btn.classList.add("d-none");
                                $('#results_modal_' + workflow_type ).modal('hide');
                                modal_body.innerHTML = "";
                                show_alert(`Error ${data["data"]["parsed_response"]["code"]} occured while submitting workflow: ${data["data"]["parsed_response"]["message"]} `, "danger");
                            }

                        });

                    // request error handler
                    request.addEventListener("error", function (e) {
                        loading_btn.classList.add("d-none");
                        $('#results_modal_' + workflow_type ).modal('hide');
                        show_alert(`Error uploading file`, "warning");

                    });
                    // Open and send the request
                    request.open("post", "https://rest.workflow-service.dev-greecevscorona.iit.demokritos.gr/submit_workflow");
                    request.setRequestHeader("Authorization", 'Bearer '+ access_token);
                    request.send(data);
                    }
                });
            }
            
        }
        // Function to upload files
        function upload(url,workflow_type,number_of_files,access_token) {

            let tmp = JSON.parse('{{data | tojson}}');
        
            // Reject if the file input is empty & throw alert
            var inputs = [];
            var labels = [];
            for (let i = 0; i < number_of_files; i++) {
                var input_id = "input_file_" + workflow_type + '_' + i;
                var label_id = "input_file_label_" + workflow_type + '_' + i;
                var new_input = document.getElementById(input_id);
                var new_label = document.getElementById(label_id);
                inputs.push(new_input);
                labels.push(new_label);
            }
            for (let i = 0; i < inputs.length; i++) {
                if(!inputs[i].value){
                    show_alert("No files selected", "warning");
                    return;
                }
            }

            
            var type = document.getElementById(workflow_type);
            var ref_number = document.getElementById("ref_number_" + type.value);
            
            var new_data = new FormData();
            var valid_workflow = 1;

            // Create a XMLHTTPRequest instance
            var request1 = new XMLHttpRequest();
            const last_index = url.lastIndexOf('/');
            const endpoint = url.slice(last_index+1);

            var new_endpoint= "can_be_submitted?ref_number=" + ref_number.value;
            let new_url = url.replace(endpoint,new_endpoint);
            
            request1.open("get", new_url);
            request1.setRequestHeader("Authorization", 'Bearer '+ access_token);
            
            new_data.append("ref_number",ref_number);
            request1.send(new_data);

            request1.addEventListener("load", function (e) {
                if (request1.status != 200)
                {
                    responseText =  request1.responseText;
                    var error_data = JSON.parse(JSON.stringify(responseText));
                    var obj = JSON.parse(error_data.replace(/'/g, '"'));
                    var data = eval(obj);

                    show_alert(`Error ${data["data"]["parsed_response"]["code"]} occured while submitting workflow: ${data["data"]["parsed_response"]["message"]} `, "danger");
                    reset(inputs,labels);
                    valid_workflow = 0;
                    return;
                }
                else
                {

                // Create a new FormData instance
                var data = new FormData();

                // Create a XMLHTTPRequest instance
                var request = new XMLHttpRequest();

                // Set the response type
                request.responseType = "text";

                // Clear any existing alerts
                alert_wrapper.innerHTML = "";

                // Disable the input during upload
    
                for (let i = 0; i < inputs.length; i++) {
                    inputs[i].disabled = true;
                }
    
                // Hide the upload button
                upload_btn_attach.classList.add("d-none");

                // Show the loading button
                loading_btn.classList.remove("d-none");


                // Show the progress bar
                progress_wrapper.classList.remove("d-none");

                // Get a reference to the file
                var input_file_references = [];
                for (let i = 0; i < inputs.length; i++) {
                    var new_ref = inputs[i].files[0];
                    input_file_references.push(new_ref);
                }

    
                var input_file_names = [];
                for (let i = 0; i < input_file_references.length; i++) {
                    var new_filename = input_file_references[i].name;
                    input_file_names.push(new_filename);
                }
    

                // Get a reference to the filesize
                var filesize = 0;
                for (let i = 0; i < input_file_references.length; i++) {
                    filesize += input_file_references[i].size;
                }
    

                // Append input files to the FormData instance
                for (let i = 0; i < input_file_references.length; i++) {
                    data.append(tmp[workflow_type]["required"][i], input_file_references[i]);
                }
                data.append("number_of_files",number_of_files);
                data.append("ref_number",ref_number.value);
                data.append("workflow_type",type.value);

                // request progress handler
                request.upload.addEventListener("progress", function (e) {

                    // Get the loaded amount and total filesize (bytes)
                    var loaded = e.loaded;
                    var total = e.total

                    // Calculate percent uploaded
                    var percent_complete = (loaded / total) * 100;

                    // Update the progress text and progress bar
                    progress.setAttribute("style", `width: ${Math.floor(percent_complete)}%`);
                    progress_status.innerText = `${Math.floor(percent_complete)}% uploaded`;

                })

                // request load handler (transfer complete)
                request.addEventListener("load", function (e) {

                    if (request.status == 200) {
                        show_alert(`Workflow with referral number ${ref_number.value} was succesfully submitted` , "success");
                    }
                    else if (request.status == 401){
                        show_alert(`Your session has expired. Please login again` , "danger");
                    }
                    else {
                        responseText =  request.responseText;
                        console.log(responseText);
                        var error_data = JSON.parse(JSON.stringify(responseText))
                        var obj = JSON.parse(error_data.replace(/'/g, '"'));
                        var data = eval(obj);
    

                        show_alert(`Error ${data["data"]["parsed_response"]["code"]} occured while submitting workflow: ${data["data"]["parsed_response"]["message"]} `, "danger");
                    }
                    reset(inputs,labels);

                });

                // request error handler
                request.addEventListener("error", function (e) {
                    reset(inputs,labels);
                    show_alert(`Error uploading file`, "warning");

                });
                // Open and send the request
                request.open("post", "https://rest.workflow-service.dev-greecevscorona.iit.demokritos.gr/submit_workflow");
                request.setRequestHeader("Authorization", 'Bearer '+ access_token);
                request.send(data);
            
                }
             
                
            });

        }
        // Function to update the input placeholder
        function input_filename(label,id) {
            var input = document.getElementById(id);
            var label = document.getElementById(label);
            label.innerText = input.files[0].name;

        }
        // Function to reset the page
        function reset(inputs,labels) {

            // Clear the input
            for (let i = 0; i < inputs.length; i++) {
                inputs[i].value = null;
                inputs[i].disabled = false;
            }
            // Show the upload button
            upload_btn_attach.classList.remove("d-none");

            // Hide the loading button
            loading_btn.classList.add("d-none");

            // Hide the progress bar
            progress_wrapper.classList.add("d-none");

            // Reset the progress bar state
            progress.setAttribute("style", `width: 0%`);

            // Reset the input placeholder
            for (let i = 0; i < labels.length; i++) {

                const id = inputs[i].id;
                const pattern = "input_file_";
                var tmp = id.slice(id.indexOf(pattern) + pattern.length);

                const lastIndex = tmp.lastIndexOf('_');

                const workflow_type = tmp.slice(0, lastIndex);
                const file_num = tmp.slice(lastIndex + 1);

                let json_data = JSON.parse('{{ data | tojson }}');
                var data = eval(json_data);

                var new_label = data[workflow_type]["required"][file_num];

                labels[i].innerText = new_label;
            }
            

        }
        // Function to upload files
        function upload_sample_id(url,workflow_type,access_token) {
            // Reject if the file input is empty & throw alert
            let tmp = JSON.parse('{{data | tojson}}');
            var inputs = [];
            var labels = [];
            
            var input_id = "input_sample_id_" + workflow_type;
            var label_id = "input_url_sample_id_" + workflow_type;
            new_input = document.getElementById(input_id);
            new_label = document.getElementById(label_id);
            console.log(new_input);
            inputs.push(new_input);
            labels.push(new_label);
        
            
            if(!new_input.value){
                show_alert("No Sample ID was provided", "warning");
                return;
            }

            var type = document.getElementById(workflow_type);
            var ref_number = document.getElementById("ref_number_" + type.value);
            
            var new_data = new FormData();
            var valid_workflow = 1;

            // Create a XMLHTTPRequest instance
            var request1 = new XMLHttpRequest();
            const last_index = url.lastIndexOf('/');
            const endpoint = url.slice(last_index+1);

            var new_endpoint= "can_be_submitted?ref_number=" + ref_number.value;
            let new_url = url.replace(endpoint,new_endpoint);
            
            request1.open("get", new_url);
            request1.setRequestHeader("Authorization", 'Bearer '+ access_token);
            
            new_data.append("ref_number",ref_number);
            request1.send(new_data);

            request1.addEventListener("load", function (e) {
                if (request1.status != 200)
                {
                    responseText =  request1.responseText;
                    var error_data = JSON.parse(JSON.stringify(responseText));
                    var obj = JSON.parse(error_data.replace(/'/g, '"'));
                    var data = eval(obj);

                    show_alert(`Error ${data["data"]["parsed_response"]["code"]} occured while submitting workflow: ${data["data"]["parsed_response"]["message"]} `, "danger");
                    reset(inputs,labels);
                    valid_workflow = 0;
                    return;
                }
                else
                {

                    // Create a new FormData instance
                    var data = new FormData();
                    var request = new XMLHttpRequest();
                    request.responseType = "text";
                    alert_wrapper.innerHTML = "";


                    // Show the loading button
                    loading_btn.classList.remove("d-none");
                    data.append("ref_number",ref_number.value);
                    data.append("workflow_type",type.value);
                    data.append("sample_id",new_input.value)

    
                    // request load handler (transfer complete)
                    request.addEventListener("load", function (e) {

                        if (request.status == 200) {
                            show_alert(`Workflow with referral number ${ref_number.value} was succesfully submitted` , "success");
                        }
                        else if (request.status == 401){
                            show_alert(`Your session has expired. Please login again` , "danger");
                        }
                        else {
                            responseText =  request.responseText;
                            console.log(responseText);
                            var error_data = JSON.parse(JSON.stringify(responseText))
                            var obj = JSON.parse(error_data.replace(/'/g, '"'));
                            var data = eval(obj);
        

                            show_alert(`Error ${data["data"]["parsed_response"]["code"]} occured while submitting workflow: ${data["data"]["parsed_response"]["message"]} `, "danger");
                        }
                        reset(inputs,labels);

                    });

                // request error handler
                request.addEventListener("error", function (e) {
                    reset(inputs,labels);
                    show_alert(`Error uploading file`, "warning");

                });
                // Open and send the request
                request.open("post", "https://rest.workflow-service.dev-greecevscorona.iit.demokritos.gr/submit_workflow");
                request.setRequestHeader("Authorization", 'Bearer '+ access_token);
                request.send(data);
                }
            });

        
        }
    </script>

    <script>

    $('[name="workflow_type"]').on('change', function() {
        var id = 'rest-form-' + $(this).attr('id');
        $('#'+id).toggle();
        $('#'+id).siblings().each(function() {
            sibling = document.getElementById(this.id);
            console.log(sibling.id);
            $('input:radio[name="input_type"]').each(function () { $(this).attr('checked', false); });

            inputs = sibling.getElementsByTagName('input');
            labels = sibling.getElementsByTagName('label');
            for (index = 0; index < inputs.length; ++index) {
                if(inputs[index].type =="text"  ) {
                    inputs[index].value = null;
                    inputs[index].disabled = false;

                }
                if (inputs[index].type =="file" && inputs[index].value != ''){
                    const id = inputs[index].id;
                    const pattern = "input_file_";
                    var tmp = id.slice(id.indexOf(pattern) + pattern.length);

                    const lastIndex = tmp.lastIndexOf('_');

                    const workflow_type = tmp.slice(0, lastIndex);
                    const file_num = tmp.slice(lastIndex + 1);

                    let json_data = JSON.parse('{{ data | tojson }}');
                    var data = eval(json_data);

                    var new_label = data[workflow_type]["required"][file_num];

                    labels[index].innerText = new_label;
                    inputs[index].value = '';
                }
                
            }
        });
       

        $('#'+id).siblings().hide();
    });

    $('[name="input_type"]').on('change', function() {
        var id = 'input-form-' + $(this).attr('id');
        $('#'+id).toggle();
        form = document.getElementById(id);
        var alt_form_name = "";
        if(id.endsWith("attach")){
            alt_form_name = "input-form-" + this.id.replace("attach","sample-id");
        }
        else{
            alt_form_name = "input-form-" +  this.id.replace("sample-id","attach");
        }
        alt_form = document.getElementById(alt_form_name);
        inputs = alt_form.getElementsByTagName('input');
        labels = alt_form.getElementsByTagName('label');
        for (index = 0; index < inputs.length; ++index) {
            if(inputs[index].type =="text"  ) {
                inputs[index].value = null;
                inputs[index].disabled = false;

            }
            if (inputs[index].type =="file" && inputs[index].value != ''){
                const id = inputs[index].id;
                const pattern = "input_file_";
                var tmp = id.slice(id.indexOf(pattern) + pattern.length);

                const lastIndex = tmp.lastIndexOf('_');

                const workflow_type = tmp.slice(0, lastIndex);
                const file_num = tmp.slice(lastIndex + 1);

                let json_data = JSON.parse('{{ data | tojson }}');
                var data = eval(json_data);

                var new_label = data[workflow_type]["required"][file_num];

                labels[index].innerText = new_label;
                inputs[index].value = '';
            }
            
        }
        $('#'+alt_form_name).hide();
        
        
        
    });


    
    </script>



</body>
</html>